//---------------------------------------------------------------------------
//PrnForm Copyright (c) 1989-2000 by Joe C. Hecht All Rights Reserved
//License - Distribution of this souce code prohibited!
//For inclusion in compiled form in your application only!
//Version 3.0 - Use at your own risk - No liability accepted!
//TExcellentHomePage: www.code4sale.com/joehecht
//Author email: joehecht@code4sale.com
//Code4Sale.com - You place to buy and sell code! www.code4sale.com

#ifndef PrnFormH
#define PrnFormH
//---------------------------------------------------------------------------
#include <Windows.hpp>
#include <Windows.h>
#include <commctrl.h>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "PrnUtils.h"
//---------------------------------------------------------------------------


#pragma pack(push, 1)
typedef struct _TPrintFormData
{
    DWORD StrucSize;
    BOOL UseAbortDialog;
    BOOL DoNotFlushGDICalls;
    BOOL Use24BitOutputOnly;
} TPrintFormData, *PPrintFormData;
#pragma pack(pop)


typedef BOOL __stdcall (*TAppCallbackFn)(DWORD UnitsDone,   //Number of units completed
                                         DWORD TotalUnits,  //Number of total units to print
                                         DWORD UserData);   //Application defined data or pointer.

typedef BOOL __fastcall (__closure *TOnPaintCallbackEvent)(HDC dc);


typedef BOOL __fastcall (__closure *TOnPaintControlCallbackEvent)(Controls::TControl* TheControl,
                                                                  HDC dc);

SIZE __fastcall VirtualClientSize(Controls::TControl* AControl);


POINT __fastcall VirtualClientScrolledOffset(Controls::TControl* AControl);

BOOL __fastcall HasClass(Controls::TControl* AObject,
                         const System::AnsiString AClassName);

BOOL __fastcall PrintForm(Forms::TScrollingWinControl* TheScrollingWinControl,
                          HDC dc,
                          BOOL Centered,
                          BOOL UsePerfectMargins);

BOOL __fastcall PrintFormEx(Forms::TScrollingWinControl* TheScrollingWinControl,
                            HDC dc,
                            BOOL Centered,
                            BOOL UsePerfectMargins,
                            TPrintFormData * lpPrintFormData);

BOOL __fastcall PrintFormXY(Forms::TScrollingWinControl* TheScrollingWinControl,
                            HDC dc,
                            int x,
                            int y,
                            int Width,
                            int Height);

BOOL __fastcall PrintFormXYEx(Forms::TScrollingWinControl* TheScrollingWinControl,
                              HDC dc,
                              int x,
                              int y,
                              int Width,
                              int Height,
                              TPrintFormData * lpPrintFormData);

BOOL __fastcall PrintTScrollingWinControl(Forms::TScrollingWinControl* TheScrollingWinControl,
                                          HDC dc,
                                          int x,
                                          int y,
                                          int Width,
                                          int Height,
                                          const RECT &ClipRect,
                                          BOOL TrueColor,
                                          TAppCallbackFn OnAppCallbackFn,
                                          DWORD OnAppCallbackData,
                                          TOnPaintCallbackEvent	OnPaintCallbackEvent,
                                          TOnPaintControlCallbackEvent OnPaintControlCallbackEvent);

BOOL __fastcall PrintTScrollingWinControlEx(Forms::TScrollingWinControl* TheScrollingWinControl,
                                            HDC dc,
                                            int x,
                                            int y,
                                            int Width,
                                            int Height,
                                            const RECT &ClipRect,
                                            TAppCallbackFn OnAppCallbackFn,
                                            DWORD OnAppCallbackData,
                                            TOnPaintCallbackEvent OnPaintCallbackEvent,
                                            TOnPaintControlCallbackEvent OnPaintControlCallbackEvent,
                                            TPrintFormData * lpPrintFormData);

BOOL __fastcall PrintTCustomForm(Forms::TScrollingWinControl* TheScrollingWinControl,
                                 HDC dc,
                                 int x,
                                 int y,
                                 int Width,
                                 int Height,
                                 const RECT &ClipRect,
                                 TPrinterAbortDialog* AbortDialog,
                                 TOnPaintCallbackEvent	OnPaintCallbackEvent,
                                 TOnPaintControlCallbackEvent OnPaintControlCallbackEvent);



void __fastcall PrnFormSetDebugMsg(BOOL value);

void __fastcall PrnFormSetDebugDoBlt(BOOL value);

void __fastcall PrnFormSetDebugUseDDB(BOOL value);

void __fastcall PrnFormSetDebugAutoUseDDB(BOOL value);

void __fastcall PrnFormSetDebugFrames(BOOL value);

void __fastcall PrnFormSetSleepValue(int value);

HWND __fastcall PrnFormSetAbortDialogHandle(HWND value);

void __fastcall PrnFormSetOutputScaleFactor(int x,
                                            int y);

void __fastcall PrnFormSetDoWinScale(BOOL value);


#endif
